NDD = {...}

local _InitAddon, _InitGUI, _RegisterEvents

local loadingFrame = CreateFrame("Frame", nil, UIParent)
loadingFrame:RegisterEvent("ADDON_LOADED")
loadingFrame:RegisterEvent("PLAYER_LOGIN")

loadingFrame:SetScript("OnEvent", function(self, event, arg1, ...)

    if event == "ADDON_LOADED" then
        _InitAddon()
    end

    if event == "PLAYER_LOGIN" then
        _InitGUI()
    end
end)

NDD.loadingFrame = loadingFrame

_InitAddon = function() 
    if (not NDDConfig) then
        NDDConfig = {}
    end

    local nddc = NDDConfig;

    if (nddc.showpartymessage == nil) then
        NDDConfig.showpartymessage = false
    end
    
    if (nddc.healthAlertSound == nil) then
        NDDConfig.healthAlertSound = "nigeldontdie.ogg"
    end

    if (nddc.healthThresholdPercent == nil) then
        NDDConfig.healthThresholdPercent = 0.3
    end

    if (nddc.petHealthAlerts == nil) then
        NDDConfig.petHealthAlerts = false
    end
    
    if (nddc.petHealthAlertSound == nil) then
        NDDConfig.petHealthAlertSound = "nigeldontdie.ogg"
    end

    if (nddc.petHealthThresholdPercent == nil) then
        NDDConfig.petHealthThresholdPercent = 0.3
    end
end

_InitGUI = function() 
    local eventFrame = CreateFrame("Frame", nil, UIParent)
    _RegisterEvents(eventFrame)
    eventFrame:SetScript("OnEvent", function(self,event,...)
        local health = UnitHealth("player",0)
        local maxHealth = UnitHealthMax("player",0)
        local petHealth = UnitHealth("pet",0)
        local petMaxHealth = UnitHealthMax("pet",0)
        local lowHealthMessage = "NIGEL DON'T DIE!"
    
        if maxHealth == nil or maxHealth == 0 then
            do return end
        end
    
        if (health/maxHealth) <= NDDConfig.healthThresholdPercent and not playerAlertThrottled then
            PlaySoundFile("Interface/AddOns/NigelDontDie/sounds/" .. NDDConfig.healthAlertSound, "Master")
            
            if NDDConfig.showpartymessage then
                SendChatMessage(lowHealthMessage)
            end
    
            playerAlertThrottled = true
        elseif (health/maxHealth) > NDDConfig.healthThresholdPercent then
            playerAlertThrottled = false
        end

        if NDDConfig.petHealthAlerts then
            if petMaxHealth == nil or petMaxHealth == 0 then
                do return end
            end

            if (petHealth/petMaxHealth) <= NDDConfig.petHealthThresholdPercent and not petAlertThrottled then
                PlaySoundFile("Interface/AddOns/NigelDontDie/sounds/" .. NDDConfig.petHealthAlertSound, "Master")
        
                petAlertThrottled = true
            elseif (petHealth/petMaxHealth) > NDDConfig.petHealthThresholdPercent then
                petAlertThrottled = false
            end
        end

    end)
end

_RegisterEvents = function (eventFrame)
    eventFrame:RegisterEvent("UNIT_HEALTH")
end